import { ChangeDetectorRef, ElementRef, OnInit, AfterViewInit, OnDestroy } from '@angular/core';
import { ScrollSpyService } from '../index';
import { ScrollSpyIndexService } from './index.service';
export interface ScrollSpyIndexComponentOptions {
    id?: string;
    spyId?: string;
    topMargin?: number;
}
export declare class ScrollSpyIndexRenderComponent implements OnInit, AfterViewInit, OnDestroy {
    private ref;
    private elRef;
    private scrollSpy;
    private scrollSpyIndex;
    scrollSpyIndexRenderOptions: ScrollSpyIndexComponentOptions;
    currentScrollPosition: number;
    items: any[];
    itemsHash: any;
    itemsToHighlight: Array<string>;
    defaultOptions: ScrollSpyIndexComponentOptions;
    changeStream$: any;
    scrollStream$: any;
    el: HTMLElement;
    constructor(ref: ChangeDetectorRef, elRef: ElementRef, scrollSpy: ScrollSpyService, scrollSpyIndex: ScrollSpyIndexService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    update(): void;
    calculateHighlight(): void;
    highlight(id: string): boolean;
    goTo(anchor: string): void;
    ngOnDestroy(): void;
}
